import { r as registerInstance, c as createEvent, h } from './chunk-395ef337.js';

class WcMaterializecssCarousel {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.items = [];
        this.template = true;
        this.mcssCarouselComponentDidLoad = createEvent(this, "mcssCarouselComponentDidLoad", 7);
    }
    componentDidLoad() {
        this.mcssCarouselComponentDidLoad.emit();
    }
    defaultRender() {
        return [
            h("div", { class: "carousel" }, this.items.map((item) => h("a", { class: "carousel-item", href: item.link, "data-id": item.id, title: item.title, target: item.target }, h("img", { src: item.url, alt: item.alt }))))
        ];
    }
    customRender() {
    }
    render() {
        if (!this.template)
            return this.defaultRender();
    }
    static get style() { return "wc-materializecss-carousel a{-webkit-transition:none;transition:none}wc-materializecss-carousel .carousel{overflow:hidden;position:relative;width:100%;height:400px;-webkit-perspective:500px;perspective:500px;-webkit-transform-style:preserve-3d;transform-style:preserve-3d;-webkit-transform-origin:0 50%;transform-origin:0 50%}wc-materializecss-carousel .carousel.carousel-slider{top:0;left:0}wc-materializecss-carousel .carousel.carousel-slider .carousel-fixed-item{position:absolute;left:0;right:0;bottom:20px;z-index:1}wc-materializecss-carousel .carousel.carousel-slider .carousel-fixed-item.with-indicators{bottom:68px}wc-materializecss-carousel .carousel.carousel-slider .carousel-item{width:100%;height:100%;min-height:400px;position:absolute;top:0;left:0}wc-materializecss-carousel .carousel.carousel-slider .carousel-item h2{font-size:24px;font-weight:500;line-height:32px}wc-materializecss-carousel .carousel.carousel-slider .carousel-item p{font-size:15px}wc-materializecss-carousel .carousel .carousel-item{visibility:hidden;width:200px;height:200px;position:absolute;top:0;left:0}wc-materializecss-carousel .carousel .carousel-item>img{width:100%}wc-materializecss-carousel .carousel .indicators{position:absolute;text-align:center;left:0;right:0;bottom:0;margin:0}wc-materializecss-carousel .carousel .indicators .indicator-item{display:inline-block;position:relative;cursor:pointer;height:8px;width:8px;margin:24px 4px;background-color:hsla(0,0%,100%,.5);-webkit-transition:background-color .3s;transition:background-color .3s;border-radius:50%}wc-materializecss-carousel .carousel .indicators .indicator-item.active{background-color:#fff}wc-materializecss-carousel .carousel .carousel-item:not(.active) .materialboxed,wc-materializecss-carousel .carousel.scrolling .carousel-item .materialboxed{pointer-events:none}"; }
}

export { WcMaterializecssCarousel as wc_materializecss_carousel };
